#include <SnoopArp>
#include <SnoopAdapter>

int main()
{
  //
  // network information
  //
  IP  myIp  = "192.168.10.10";
  MAC myMac = "00-0C-29-6F-AE-3E";
  IP  gwIp  = "192.168.10.1";

  //
  // buffer
  //
  static const int BUF_SIZE = sizeof(ETH_HDR) + sizeof(ARP_HDR);
  u_char buf[BUF_SIZE];
  ETH_HDR* ethHdr = (ETH_HDR*)buf;
  ARP_HDR* arpHdr = (ARP_HDR*)(buf + sizeof(ETH_HDR));

  //
  // ethernet header
  //
  ethHdr->ether_dhost = MAC::broadcastMac();
  ethHdr->ether_shost = myMac;
  ethHdr->ether_type  = htons(ETHERTYPE_ARP);

  //
  // arp header
  //
  arpHdr->ar_hrd = htons(ARPHRD_ETHER);
  arpHdr->ar_pro = htons(ETHERTYPE_IP);
  arpHdr->ar_hln = 6;
  arpHdr->ar_pln = 4;
  arpHdr->ar_op  = htons(ARPOP_REQUEST);
  arpHdr->ar_sa  = myMac;
  arpHdr->ar_si  = htonl(myIp);
  arpHdr->ar_ta  = MAC::cleanMac();
  arpHdr->ar_ti  = htonl(gwIp);

  //
  // send packet
  //
  SnoopAdapter adapter;
  adapter.open();
  adapter.write(buf, BUF_SIZE);
  adapter.close();

  return 0;
}
